﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using AForge.Video.DirectShow;

namespace VP8.NET.Example
{
    public partial class DeviceSelection : Form
    {
        public event EventHandler<DeviceSelectionEventArgs> DeviceSelected;

        private Dictionary<string, FilterInfo> DeviceMap = new Dictionary<string, FilterInfo>();

        public DeviceSelection()
        {
            InitializeComponent();

            var videoDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
            foreach (FilterInfo videoDevice in videoDevices)
            {
                DeviceMap[videoDevice.Name] = videoDevice;
                lstDevices.Items.Add(videoDevice.Name);
            }

            lstDevices.DoubleClick += new EventHandler(lstDevices_DoubleClick);
        }

        private void lstDevices_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnSelect.Enabled = (lstDevices.SelectedItem != null);
        }

        private void lstDevices_DoubleClick(object sender, EventArgs e)
        {
            btnSelect.PerformClick();
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            if (lstDevices.SelectedItem != null)
            {
                var handler = DeviceSelected;
                if (handler != null)
                {
                    handler(this, new DeviceSelectionEventArgs
                    {
                        VideoDevice = DeviceMap[(string)lstDevices.SelectedItem]
                    });
                }
                Hide();
            }
        }
    }
}
